// @(#)root/eve:$Id: TEveElementEditor.h 22539 2008-03-08 14:36:37Z rdm $
// Authors: Matevz Tadel & Alja Mrak-Tadel: 2006, 2007
// Stolen: JGennaro 10/2011 AA as CRESTCrystalEditor !!!

/*************************************************************************
 * Copyright (C) 1995-2007, Rene Brun and Fons Rademakers.               *
 * All rights reserved.                                                  *
 *                                                                       *
 * For the licensing terms see $ROOTSYS/LICENSE.                         *
 * For the list of contributors see $ROOTSYS/README/CREDITS.             *
 *************************************************************************/

#ifndef CRESTCRYSTALTUBEDITOR_H
#define CRESTCRYSTALTUBEDITOR_H

#include "TGedFrame.h"

class TGCheckButton;
class TGNumberEntry;
class TGColorSelect;
class TGLabel;
class TGPictureButton;

class TEveElement;
class CRESTCrystal;
class TEveTransSubEditor;

class CRESTCrystalEditor : public TGedFrame
{
   CRESTCrystalEditor(const CRESTCrystalEditor&);            // Not implemented
   CRESTCrystalEditor& operator=(const CRESTCrystalEditor&); // Not implemented

protected:
   //TEveElement         *fRE; // Model object.
   CRESTCrystal         *fRE; // Model object. Derives from TEveGeoShape so indirectly derives from TEVeELement.

   //TGHorizontalFrame   *fHFrame;
   TGVerticalFrame   *fVFrame;
   //TGLabel             *fPreLabel;
   //TGCheckButton       *fRnrSelf;
   //TGCheckButton       *fRnrChildren;
   //TGCheckButton       *fRnrState;
   //TGColorSelect       *fMainColor;
   TGLabel       			 *fBusLabel;
   TGLabel       			 *fSedecimLabel;
   TGLabel       			 *fPinLabel;
	 TGPictureButton		 *fHistButton;
   //TGNumberEntry       *fTransparency;
   //TEveTransSubEditor  *fTrans;

public:
   CRESTCrystalEditor(const TGWindow* p=0, Int_t width=170, Int_t height=30,
                     UInt_t options=kChildFrame, Pixel_t back=GetDefaultFrameBackground());
   virtual ~CRESTCrystalEditor() {}

   void SetModel(TObject* obj);

   void DoHist();
	/*
   void DoRnrSelf();
   void DoRnrChildren();
   void DoRnrState();
   void DoMainColor(Pixel_t color);
   void DoTransparency();
	 */

   ClassDef(CRESTCrystalEditor, 2); // Editor for CRESTCrystal class.
};

#endif
