#ifndef CRESTCRYSTALVIEW_H
#define CRESTCRYSTALVIEW_H
// Multi-view (3d, rphi, rhoz) service class using EVE Window Manager.
// Author: Matevz Tadel 2009
// Copied by JGennaro

#include <TEveManager.h>
#include <TEveBrowser.h>
#include <TEveWindow.h>
#include <TH1F.h>
//#include <TRootEmbeddedCanvas.h>
#include <TCanvas.h>

#include "CRESTCrystal.h"

// CRESTCrystalView
//
// Structure encapsulating detailed view of a crystal tube

class CRESTCrystalView
{
	public:
   //TEveProjectionManager *fVetoMgr;
	 /*
   TEveViewer            *f3DView; //has no projection manager
   TEveViewer            *fVetoView;//has no projection manager. How can we draw all vetos in 2D?
   TEveViewer            *fCrystalView; //has a 2D projection manager.
	 */
	 //TRootEmbeddedCanvas 	*fHistCanvas; //draw the ADC distribution here!
	 TCanvas 	*fHistCanvas; //draw the ADC distribution here!
	 CRESTCrystal* fCrystal; //the tube whose details will be shown.
	 TH1F			*fADC0Hist; //its ADC plot
	 TH1F			*fADC1Hist; //its ADC plot

   CRESTCrystalView();
	 void SetElement(CRESTCrystal* crystal); //
   void ImportADCHists();
	 void DrawHist(Int_t type);

		ClassDef(CRESTCrystalView, 1)   // Detailed view of a CRESTCrystal object.
};

#endif
