#ifndef CRESTNAVHANDLER_H
#define CRESTNAVHANDLER_H

#include "Riostream.h"
#include "TROOT.h"
#include "TObject.h"
#include "TTree.h"
#include "UC_Event.h"

//_______________________________________________________________________________
class CRESTNavHandler : public TObject
{
	private:
		void GetEntry(Int_t entry); //make private so we are careful not to go to an invalid entry
	public:
		CRESTNavHandler();
		TTree*			fEventTree; //if inputting from a tree, here's the tree
		UC_Event*		fCurrentEvent; //no matter the form of input, here is the final stage (UC_Event*)
		Int_t				fCurrentEventNumber; //Local definition: this is the ith event I'VE READ.

		void 				Init(TTree* t=0);

		//Navigation functions- - - - - - - - - - - - - - - - - - - - - - - - - - - - 
		void 				Fwd();
		void 				Bck();
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

		ClassDef(CRESTNavHandler, 4)   // Manages the input front end and messaging back end of CrestViewer
};

#endif 
