// @(#)root/eve:$Id: TEveElementEditor.h 22539 2008-03-08 14:36:37Z rdm $
// Authors: Matevz Tadel & Alja Mrak-Tadel: 2006, 2007
// Stolen: JGennaro 10/2011 AA as CRESTVetoPaddleEditor !!!

/*************************************************************************
 * Copyright (C) 1995-2007, Rene Brun and Fons Rademakers.               *
 * All rights reserved.                                                  *
 *                                                                       *
 * For the licensing terms see $ROOTSYS/LICENSE.                         *
 * For the list of contributors see $ROOTSYS/README/CREDITS.             *
 *************************************************************************/

#ifndef CRESTVETOPADDLEEDITOR_H
#define CRESTVETOPADDLEEDITOR_H

#include "TGedFrame.h"

class TGCheckButton;
class TGNumberEntry;
class TGColorSelect;
class TGLabel;
class TGPictureButton;

class TEveElement;
class CRESTVetoPaddle;
class TEveTransSubEditor;

class CRESTVetoPaddleEditor : public TGedFrame
{
   CRESTVetoPaddleEditor(const CRESTVetoPaddleEditor&);            // Not implemented
   CRESTVetoPaddleEditor& operator=(const CRESTVetoPaddleEditor&); // Not implemented

protected:
   //TEveElement         *fRE; // Model object.
   CRESTVetoPaddle         *fRE; // Model object. Derives from TEveGeoShape so indirectly derives from TEVeELement.

   TGHorizontalFrame   *fHFrame0;
   TGHorizontalFrame   *fHFrame1;
   //TGLabel             *fPreLabel;
   //TGCheckButton       *fRnrSelf;
   //TGCheckButton       *fRnrChildren;
   //TGCheckButton       *fRnrState;
   //TGColorSelect       *fMainColor;
   TGLabel       			 *fTubeLabel0;
   TGLabel       			 *fBusLabel0;
   TGLabel       			 *fSedecimLabel0;
   TGLabel       			 *fPinLabel0;
   TGLabel       			 *fTubeLabel1;
   TGLabel       			 *fBusLabel1;
   TGLabel       			 *fSedecimLabel1;
   TGLabel       			 *fPinLabel1;
	 TGPictureButton		 *fHistButton;

public:
   CRESTVetoPaddleEditor(const TGWindow* p=0, Int_t width=170, Int_t height=30,
                     UInt_t options=kChildFrame, Pixel_t back=GetDefaultFrameBackground());
   virtual ~CRESTVetoPaddleEditor() {}

   virtual void SetModel(TObject* obj);

   void DoHist();
	/*
   void DoRnrSelf();
   void DoRnrChildren();
   void DoRnrState();
   void DoMainColor(Pixel_t color);
   void DoTransparency();
	 */

   ClassDef(CRESTVetoPaddleEditor, 1); // Editor for CRESTVetoPaddle class.
};

#endif
