#ifndef CRESTVETOPADDLEVIEW_H
#define CRESTVETOPADDLEVIEW_H
// Multi-view (3d, rphi, rhoz) service class using EVE Window Manager.
// Author: Matevz Tadel 2009
// Copied by JGennaro

#include <TEveManager.h>
#include <TEveBrowser.h>
#include <TEveWindow.h>
#include <TH1F.h>
//#include <TRootEmbeddedCanvas.h>
#include <TCanvas.h>

#include "CRESTVetoPaddle.h"

// CRESTVetoPaddleView
//
// Structure encapsulating detailed view of a veto paddle

class CRESTVetoPaddleView
{
	public:
   //TEveProjectionManager *fVetoMgr;
	 /*
   TEveViewer            *f3DView; //has no projection manager
   TEveViewer            *fVetoView;//has no projection manager. How can we draw all vetos in 2D?
   TEveViewer            *fVetoPaddleView; //has a 2D projection manager.
	 */
	 //TRootEmbeddedCanvas 	*fHistCanvas; //draw the ADC distribution here!
	 TCanvas 	*fHistCanvas; //draw the ADC distribution(s) here!
	 CRESTVetoPaddle* fVetoPaddle; //the paddle whose details will be shown.
	 TH1F			*fTube0ADCHist; //its ADC plot
	 TH1F			*fTube1ADCHist; //its ADC plot

   CRESTVetoPaddleView();
	 void SetElement(CRESTVetoPaddle* paddle); //
   void ImportADCHists();
	 void DrawHist(Int_t type);

		ClassDef(CRESTVetoPaddleView, 1)   // Detailed view of a CRESTVetoPaddle object.
};

#endif
