
#include "CRESTCrystal.h"
#include <iostream>

class TGeoHMatrix;
class TGeoShape;

class TEveElement;

ClassImp(CRESTCrystal)

CRESTCrystal::CRESTCrystal(const char* name, const char* title, Int_t id, TGeoHMatrix* trans, TGeoShape* shape, Bool_t is_assembly) : CRESTComponent(name,title, id,trans,shape,is_assembly),
	fADC0Hist( TString::Format("hADC0_%s",title),TString::Format("%s's ADC0 Spectrum",title),300,0,3000), 
	fADC1Hist( TString::Format("hADC1_%s",title),TString::Format("%s's ADC1 Spectrum",title),300,0,3000)
{
	cout << "Making a CRESTCrystal ";
	fTubeNum=-1;
	fBus=-1;
	fSedecim=-1;
	fPin=-1;
	fADC0Hist.SetLineColor(kBlue);
	fADC1Hist.SetLineColor(kRed);

	SetMainColor(kWhite);
	SetMainTransparency(0);

	//these 2 should now be set in the CRESTComponent constructor via the is_assembly parameter.
	//SetPickable(kTRUE);
	//SetRnrSelfChildren(kTRUE,kFALSE);

	cout << "With name " << name << ", title " << title << " and CRESTId " << fCRESTId << endl;
	if(!GetRnrSelf()) {
		cout << "Warning in CRESTCrystal constructor: Not rendering self" << endl;
	}
}

TString CRESTCrystal::GetHighlightTooltip() 
{
	cout << "Getting highlight tooltip for CRESTCrystal." << endl;
	TString hltt = TString::Format("Crystal %d, (B%d, S%d, P%d)",fTubeNum,fBus,fSedecim,fPin);
	return hltt;
}
TH1F* CRESTCrystal::GetADCHist(Int_t type) 
{
	if(type==0) return &fADC0Hist;
	if(type==1) return &fADC1Hist;
	cout << "Warning in <CRESTCrystal::GetADCHist(type = " << type << "): Returning null pointer to TH1F." << endl;
	return (TH1F*)(0);
}
