// Multiview (3d, rphi, rhoz) service class using EVE Window Manager.
// Author: Matevz Tadel 2009

// MultiView
//
// Detailed view of a CRESTCrystal
// Should be used in compiled mode.

#include "CRESTCrystalView.h"
#include "TGPack.h"
#include <iostream>
#include <TRandom.h>
#include <TLegend.h>
//#include <TCanvas.h>

ClassImp(CRESTCrystalView);

CRESTCrystalView::CRESTCrystalView()
{
	
	/*
	TEveWindowSlot *slot = 0;
	TEveWindowPack *pack = 0;
	slot = TEveWindow::CreateWindowInTab(gEve->GetBrowser()->GetTabRight());
	pack = slot->MakePack();
	pack->SetElementName("CREST Crystal Detail");
	pack->SetHorizontal();
	pack->SetShowTitleBar(kFALSE);
	TEveWindowSlot *slot2 = pack->NewSlot();
	//pack->NewSlot()->MakeCurrent();
	*/
	/*
	fHistCanvas = new TRootEmbeddedCanvas("Crystal Detail",(TGPack*)(pack->GetPack()),400,300);
	pack->GetPack()->AddFrame(fHistCanvas,new TGLayoutHints(kLHintsExpandX,kLHintsExpandY));	
	*/
	//slot2->StartEmbedding();
	//fHistCanvas = new TCanvas("Root Canvas");	
	//slot2->StopEmbedding();

	/*
	gEve->GetBrowser()->StartEmbedding(1);
	gROOT->ProcessLineFast("new TCanvas");
	fHistCanvas = (TCanvas*) gPad;
	gEve->GetBrowser()->StopEmbedding("Crystal Detail Canvas");
	*/
}

void CRESTCrystalView::SetElement(CRESTCrystal* crystal)
{
	cout << "Info in <CRESTCrystalView::SetElement>: Setting element to crystal with title " << crystal->GetElementTitle() << endl;
	fCrystal = crystal;
}

void CRESTCrystalView::ImportADCHists()
{
	if(!fCrystal) {
		cout << "Error in <CRESTCrystalView::ImportADCHists>: fCrystal is null. Not importing ADC histograms. " << endl;
	}
	fADC0Hist = fCrystal->GetADCHist(0);
	fADC1Hist = fCrystal->GetADCHist(1);
}

void CRESTCrystalView::DrawHist(Int_t type)
{
	//fHistCanvas->GetCanvas()->cd();

	if(!fCrystal) {
		cout << "Error in <CRESTCrystalView::ImportADCHists>: fCrystal is null. Not drawing ADC histograms. " << endl;
	}
	fHistCanvas = new TCanvas(fCrystal->GetElementName());	
	fHistCanvas->cd();
	if(type==0) fADC0Hist->Draw();
	else if(type==1) fADC1Hist->Draw();
	else if(type==2) { //draw both
		fADC0Hist->Draw();
		fADC1Hist->Draw("same");
		TLegend* a_legend = new TLegend(0.2,0.5,0.7,0.75);
		//a_legend->SetHeader("ADC");
		a_legend->AddEntry(fADC0Hist,"ADC0");
		a_legend->AddEntry(fADC1Hist,"ADC1");
		a_legend->SetTextSize(0.02);
		a_legend->SetFillStyle(0);
		a_legend->Draw();
	}
	else if(type==3) { //testing mode!
		TRandom r(0);
		for (Int_t i=0;i<4000;i++) {
			fADC0Hist->Fill(r.Gaus(0.5,0.1)*2048.0);
			fADC1Hist->Fill(r.Gaus(0.25,0.2)*2048.0);
			fADC1Hist->Fill(r.Gaus(0.75,0.2)*2048.0);
		}
		fADC0Hist->Draw();
		fADC1Hist->SetLineColor(kRed);
		fADC1Hist->Draw("same");
		TLegend* a_legend = new TLegend(0.2,0.25,0.7,0.75);
		//a_legend->SetHeader("ADC");
		a_legend->AddEntry(fADC0Hist,"ADC0");
		a_legend->AddEntry(fADC1Hist,"ADC1");
		a_legend->SetTextSize(0.02);
		a_legend->SetFillStyle(0);
		a_legend->Draw();
	}
	else {
		cout << "Warning in <CRESTCrystalView::DrawHist>: No histogram drawn because of bad type = " << type << endl;
	}
	return;
}
