
#include "CRESTHit.h"
#include <iostream>
#include "CRESTComponent.h"
#include "UC_Event.h"
#include <TEveGeoShape.h>
ClassImp(CRESTHit)

//create the crest hit from this UC_Event, using the array info at index idx
CRESTHit::CRESTHit(UC_Event* evt, Int_t idx,CRESTComponent* detector) : TObject() 
{
	cout << "Making a CRESTHit." << endl;
	if(!detector) {
		cout << "Warning in <CRESTHit::CRESTHit>: detector constructor parameter is null. Behavior unknown!" << endl;
	}
	fHitIndex=-1; //index in the UC_Event that spawned us
	fEventId=-1; //id of the UC_Event that spawned us (starts at 0 in each freeze)
	fFreezeTick=-1; //id of the UC_FreezeCycle that spawned us
	fT=-1; //id of the UC_FreezeCycle that spawned us
	fCRESTId=-1; //global ID of the detector element that spawned us
	fTubeNum=-1;  //the rest of these should look familiar...
	fADC0=-1;
	fADC1=-1;
	fTDC=-1;
	fIsVeto=kFALSE;
	fBusId=-1;
	fSTACId=-1;
	fPMTId=-1;
	fXLoc=0;
	fYLoc=0;
	fZLoc=0;
	Bool_t success = kFALSE;
	//find the detector
	if(evt && idx>=0 && detector) {
		success = InitFromEvent(evt,idx, detector);
	}
	if(success) {
		cout << "Info in <CRESTHit::CRESTHit(UC_Event*)>Successfully initalized this CRESTHit from the event." << endl;	
	} else {
		cout << "Warning in <CRESTHit::CRESTHit(UC_Event*)>Failed to initalized this CRESTHit from the event." << endl;	
	}
}

Bool_t CRESTHit::InitFromEvent(UC_Event* evt, Int_t idx, CRESTComponent* detector)  //fill in the information from the UC_Event at the index
{
	Int_t nhits = evt->fHitCount;
	if(!idx<nhits) return kFALSE;
	//if we're here, that means we have a valid index, so let's fill in the data.
	fHitIndex=idx;
	fEventId=evt->fEventId;
	fFreezeTick=evt->fEventId;
	fT=evt->fT;
	fTubeNum=evt->fTubeNum[idx];
	fADC0=evt->fADC0[idx];
	fADC1=evt->fADC1[idx];
	fTDC=evt->fTDC[idx];
	fIsVeto=kFALSE;
	fBusId=evt->fBusId[idx];
	fSTACId=evt->fSTACId[idx];
	fPMTId=evt->fPMTId[idx];
	fXLoc = detector->fXLoc;
	fYLoc = detector->fYLoc;
	fZLoc = detector->fZLoc;
	//fCRESTId = SearchForTheCRESTIdThatBelongsToThisHit! FIXME
	return kTRUE;
}
