
#include "CRESTNavHandler.h"
#include "TTree.h"
#include <iostream>


ClassImp(CRESTNavHandler)

CRESTNavHandler::CRESTNavHandler() 
{
	fEventTree=0;
	fCurrentEvent=0;
	fCurrentEventNumber=-1;
	//Init();
}

void CRESTNavHandler::Init(TTree* tree)
{
	fEventTree=tree;
	if(fCurrentEvent) delete fCurrentEvent; fCurrentEvent=0;
	fCurrentEvent = new UC_Event();
	if(fEventTree) tree->SetBranchAddress("evt.",&fCurrentEvent);
	fCurrentEvent=0;
	fCurrentEventNumber=0;
	GetEntry(fCurrentEventNumber);
}

void CRESTNavHandler::Fwd()
{
	std::cout << "Info in <CRESTNavHandler::Fwd>Moving forward through events." << endl;
	if(!fEventTree || !fCurrentEventNumber) {
		cout << "Exiting Fwd: bad pointers." << endl;
		return;
	}
	if(fCurrentEventNumber < fEventTree->GetEntries()-1) {
		fCurrentEventNumber++;
		GetEntry(fCurrentEventNumber);
		cout << "Loaded event number " << fCurrentEventNumber << endl;
	} else {
		cout << "Already at last event of event tree - did not move forward. Jerk." << endl;
	}
}

void CRESTNavHandler::Bck()
{
	std::cout << "Info in <CRESTNavHandler::Fwd>Moving backward through events." << endl;
	if(!fEventTree || !fCurrentEventNumber) {
		cout << "Exiting Bck: bad pointers." << endl;
		return;
	}
	if(fCurrentEventNumber > 0 ) {
		fCurrentEventNumber--;
		GetEntry(fCurrentEventNumber);
		cout << "Loaded event number " << fCurrentEventNumber << endl;
	} else {
		cout << "Already at first event of event tree - did not move backwards. Jerk." << endl;
	}
}

void CRESTNavHandler::GetEntry(Int_t entry) {
	cout << "Entered <CRESTNavHandler::GetEntry> " << endl;
	if(!fEventTree) {
		cout << "Error in <CRESTNavHandler::GetEntry>: Null event tree! Not getting entry " << entry << endl;
		return;
	}
	if(entry<0 || entry > fEventTree->GetEntries()-1) {
		cout << "Error in <CRESTNavHandler::GetEntry>: Bad entry request! Not getting entry " << entry << endl;
		return;
	}
	fEventTree->GetEntry(entry);
	cout << "Info in <CRESTNavHandler::GetEntry>: Got entry " << entry << endl;
}
