
#include "CRESTVetoPaddle.h"
#include <iostream>

class TEveElement;

ClassImp(CRESTVetoPaddle)

CRESTVetoPaddle::CRESTVetoPaddle(const char* name, const char* title, Int_t id, TGeoHMatrix* trans, TGeoShape* shape,Bool_t is_assembly) : CRESTComponent(name,title, id,trans,shape, is_assembly),
	fTube0ADCHist( TString::Format("hTube0ADC_%s",title),TString::Format("%s's Side0 ADC Spectrum",title),300,0,3000), 
	fTube1ADCHist( TString::Format("hTube1ADC_%s",title),TString::Format("%s's Side1 ADC Spectrum",title),300,0,3000)
{
	cout << "Making a CRESTVetoPaddle ";
	fCRESTId = id;
	fTubeNum0=-1;
	fBus0=-1;
	fSedecim0=-1;
	fPin0=-1;
	fTubeNum1=-1;
	fBus1=-1;
	fSedecim1=-1;
	fPin1=-1;
	fXLoc=0;
	fYLoc=0;
	fZLoc=0;
	fLongDim=-1;
	fLongDimLength=-1;
	//fIsAssembly = kFALSE;
	//SetRnrSelf(kTRUE);
	//SetPickable(kTRUE);
	SetMainColor(kGreen);
	fTube0ADCHist.SetLineColor(kBlue);
	fTube1ADCHist.SetLineColor(kRed);
//	SetMainTransparency(VETO_TRANS);
	cout << "With name " << name << ", title " << title << " and CRESTId " << fCRESTId << endl;
}

TString CRESTVetoPaddle::GetHighlightTooltip() 
{
	TString hltt = TString::Format("Veto paddle %s (tubes %d, %d)",GetElementTitle(),fTubeNum0,fTubeNum1);
	return hltt;
}
TH1F* CRESTVetoPaddle::GetADCHist(Int_t type) 
{
	if(type==0) return &fTube0ADCHist;
	if(type==1) return &fTube1ADCHist;
	cout << "Warning in <CRESTVetoPaddle::GetADCHist(type = " << type << "): Returning null pointer to TH1F." << endl;
	return (TH1F*)(0);
}
