// Multiview (3d, rphi, rhoz) service class using EVE Window Manager.
// Author: Matevz Tadel 2009

// MultiView
//
// Detailed view of a CRESTVetoPaddle
// Should be used in compiled mode.

#include "CRESTVetoPaddleView.h"
#include "TGPack.h"
#include <iostream>
#include <TRandom.h>
#include <TLegend.h>
//#include <TCanvas.h>

ClassImp(CRESTVetoPaddleView);

CRESTVetoPaddleView::CRESTVetoPaddleView()
{
	
	/*
	TEveWindowSlot *slot = 0;
	TEveWindowPack *pack = 0;
	slot = TEveWindow::CreateWindowInTab(gEve->GetBrowser()->GetTabRight());
	pack = slot->MakePack();
	pack->SetElementName("CREST VetoPaddle Detail");
	pack->SetHorizontal();
	pack->SetShowTitleBar(kFALSE);
	TEveWindowSlot *slot2 = pack->NewSlot();
	//pack->NewSlot()->MakeCurrent();
	*/
	/*
	fHistCanvas = new TRootEmbeddedCanvas("VetoPaddle Detail",(TGPack*)(pack->GetPack()),400,300);
	pack->GetPack()->AddFrame(fHistCanvas,new TGLayoutHints(kLHintsExpandX,kLHintsExpandY));	
	*/
	//slot2->StartEmbedding();
	//fHistCanvas = new TCanvas("Root Canvas");	
	//slot2->StopEmbedding();

	/*
	gEve->GetBrowser()->StartEmbedding(1);
	gROOT->ProcessLineFast("new TCanvas");
	fHistCanvas = (TCanvas*) gPad;
	gEve->GetBrowser()->StopEmbedding("VetoPaddle Detail Canvas");
	*/
}

void CRESTVetoPaddleView::SetElement(CRESTVetoPaddle* paddle)
{
	cout << "Info in <CRESTVetoPaddleView::SetElement>: Setting element to paddle with title " << paddle->GetElementTitle() << endl;
	fVetoPaddle = paddle;
}

void CRESTVetoPaddleView::ImportADCHists()
{
	if(!fVetoPaddle) {
		cout << "Error in <CRESTVetoPaddleView::ImportADCHists>: fVetoPaddle is null. Not importing ADC histograms. " << endl;
	}
	fTube0ADCHist = fVetoPaddle->GetADCHist(0);
	fTube1ADCHist = fVetoPaddle->GetADCHist(1);
}

void CRESTVetoPaddleView::DrawHist(Int_t side)
{
	//fHistCanvas->GetCanvas()->cd();

	if(!fVetoPaddle) {
		cout << "Error in <CRESTVetoPaddleView::ImportADCHists>: fVetoPaddle is null. Not drawing ADC histograms. " << endl;
	}
	fHistCanvas = new TCanvas(fVetoPaddle->GetElementName());	
	fHistCanvas->cd();
	if(side==0) fTube0ADCHist->Draw();
	else if(side==1) fTube1ADCHist->Draw();
	else if(side==2) {
		fTube0ADCHist->Draw();
		fTube1ADCHist->Draw("same");
		TLegend* a_legend = new TLegend(0.2,0.4,0.7,0.9);
		a_legend->SetHeader("ADC");
		a_legend->AddEntry(fTube0ADCHist,"ADC0");
		a_legend->AddEntry(fTube1ADCHist,"ADC1");
		a_legend->Draw();
	}
	else if(side==3) { //testing mode!
		TRandom r(0);
		for (Int_t i=0;i<4000;i++) {
			fTube0ADCHist->Fill(r.Gaus(0.5,0.1)*2048.0);
			fTube1ADCHist->Fill(r.Gaus(0.25,0.2)*2048.0);
			fTube1ADCHist->Fill(r.Gaus(0.75,0.2)*2048.0);
			TLegend* a_legend = new TLegend(0.2,0.5,0.7,0.75);
			a_legend->SetTextSize(0.02);
			a_legend->SetHeader("ADC");
			a_legend->AddEntry(fTube0ADCHist,"ADC0");
			a_legend->AddEntry(fTube1ADCHist,"ADC1");
		}
		fTube0ADCHist->Draw();
		fTube1ADCHist->Draw("same");
	}
	else {
		cout << "Warning in <CRESTVetoPaddleView::DrawHist>: No histogram drawn because of bad side = " << side << endl;
	}
	return;
}
